'''
MWO_CleaupSelective.py

UI to remove Schematics, System Diagrams, Data Files, EM Structures, Data Sets, Graphs,
Measurements, Output Equations, Optimization Goals, Yield Goals


'''
from pyawr_utils import awrde_utils
from functools import partial
from PyQt5.QtWidgets import QApplication, QMainWindow
from CleanupSelective_MainWindow import Ui_MainWindow
from functools import partial
#
t = True
f = False
#
#**************************************************************
#
class MainWindow(QMainWindow, Ui_MainWindow):
    def __init__(self):#-----------------------------------------------
        super().__init__()        #Initialize all inherited classes
        self.setupUi(self)
        self.ConnectSignals()
        self.Initialize()
        #
    def ConnectSignals(self):#----------------------------------------
        self.tabWidget.currentChanged.connect(self.MainTabHandler)
        self.pushButton_RemoveItems.clicked.connect(self.PerformCleanup)
        self.pushButton_Refresh.clicked.connect(self.PopulateLists)
        self.pushButton_Cancel.clicked.connect(self.Cancel)
        self.pushButton_RemoveItems_2.clicked.connect(self.PerformCleanup)
        self.pushButton_Refresh_2.clicked.connect(self.PopulateLists)
        self.pushButton_Cancel_2.clicked.connect(self.Cancel)        
        #
        self.listWidget_schem.itemClicked.connect(partial(self.ListItemSelected, 'Schematic'))
        self.pushButton_schem_select_all.clicked.connect(partial(self.SelectAll, 'Schematic'))
        self.pushButton_schem_unselect_all.clicked.connect(partial(self.UnselectAll, 'Schematic'))
        #
        self.listWidget_SystemDiagram.itemClicked.connect(partial(self.ListItemSelected, 'System Diagram'))
        self.pushButton_sysdiag_select_all.clicked.connect(partial(self.SelectAll, 'System Diagram'))
        self.pushButton_sysdiag_unselect_all.clicked.connect(partial(self.UnselectAll, 'System Diagram'))        
        #
        self.listWidget_em.itemClicked.connect(partial(self.ListItemSelected, 'EM Structure'))
        self.pushButton_em_select_all.clicked.connect(partial(self.SelectAll, 'EM Structure'))
        self.pushButton_em_unselect_all.clicked.connect(partial(self.UnselectAll, 'EM Structure'))        
        #
        self.listWidget_graph.itemClicked.connect(partial(self.ListItemSelected, 'Graph'))
        self.pushButton_graph_select_all.clicked.connect(partial(self.SelectAll, 'Graph'))
        self.pushButton_graph_unselect_all.clicked.connect(partial(self.UnselectAll, 'Graph'))        
        #
        self.listWidget_data_file.itemClicked.connect(partial(self.ListItemSelected, 'Data File'))
        self.pushButton_data_file_select_all.clicked.connect(partial(self.SelectAll, 'Data File'))
        self.pushButton_data_file_unselect_all.clicked.connect(partial(self.UnselectAll, 'Data File'))        
        #
        self.listWidget_out_eqn.itemClicked.connect(partial(self.ListItemSelected, 'Output Equation'))
        self.pushButton_out_eqn_select_all.clicked.connect(partial(self.SelectAll, 'Output Equation'))
        self.pushButton_out_eqn_unselect_all.clicked.connect(partial(self.UnselectAll, 'Output Equation'))        
        #
        self.listWidget_opt_goal.itemClicked.connect(partial(self.ListItemSelected, 'Optimization Goal'))
        self.pushButton_opt_goal_select_all.clicked.connect(partial(self.SelectAll, 'Optimization Goal'))
        self.pushButton_opt_goal_unselect_all.clicked.connect(partial(self.UnselectAll, 'Optimization Goal'))        
        #
        self.listWidget_yield_goal.itemClicked.connect(partial(self.ListItemSelected, 'Yield Goal'))
        self.pushButton_yield_goal_select_all.clicked.connect(partial(self.SelectAll, 'Yield Goal'))
        self.pushButton_yield_goal_unselect_all.clicked.connect(partial(self.UnselectAll, 'Yield Goal'))        
        #        
    def Initialize(self):#-------------------------------------------
        self.awrde = awrde_utils.establish_link()
        self.Project = awrde_utils.Project(self.awrde)
        #
        self.tabWidget.setCurrentIndex(0)
        self.schem_set = set()
        self.sysdiag_set = set()
        self.em_set = set()
        self.graph_set = set()
        self.data_file_set = set()
        self.out_eqn_set = set()
        self.opt_goal_set = set()
        self.yield_goal_set = set()
        #
        self.PopulateLists()
        #
    def ListItemSelected(self, WhichList, item):#-------------------------------
        if WhichList == 'Schematic':
            if item.isSelected():
                self.schem_set.add(item.text())
            else:
                self.schem_set.remove(item.text())
            #end if
            #
        elif WhichList == 'System Diagram':
            if item.isSelected():
                self.sysdiag_set.add(item.text())
            else:
                self.sysdiag_set.remove(item.text())
            #end if
            #
        elif WhichList == 'EM Structure':
            if item.isSelected():
                self.em_set.add(item.text())
            else:
                self.em_set.remove(item.text())
            #end if
            #
        elif WhichList == 'Graph':
            if item.isSelected():
                self.graph_set.add(item.text())
            else:
                self.graph_set.remove(item.text())
            #end if
            #
        elif WhichList == 'Data File':
            if item.isSelected():
                self.data_file_set.add(item.text())
            else:
                self.data_file_set.remove(item.text())
            #end if
            #
        elif WhichList == 'Output Equation':
            if item.isSelected():
                self.out_eqn_set.add(item.text())
            else:
                self.out_eqn_set.remove(item.text())
            #end if
            #
        elif WhichList == 'Optimization Goal':
            if item.isSelected():
                self.opt_goal_set.add(item.text())
            else:
                self.opt_goal_set.remove(item.text())
            #end if
            #
        elif WhichList == 'Yield Goal':
            if item.isSelected():
                self.yield_goal_set.add(item.text())
            else:
                self.yield_goal_set.remove(item.text())
            #end if        
        #end if
        #
    def SelectAll(self, WhichList):#----------------------------------------------
        if WhichList == 'Schematic':
            NumItems = self.listWidget_schem.count()
            for i in range(NumItems):
                self.listWidget_schem.item(i).setSelected(True)
            #end for
            self.schem_set = set(self.schem_list)
            #
        elif WhichList == 'System Diagram':
            NumItems = self.listWidget_SystemDiagram.count()
            for i in range(NumItems):
                self.listWidget_SystemDiagram.item(i).setSelected(True)
            #end for
            self.sysdiag_set = set(self.sysdiag_list)
            #
        elif WhichList == 'EM Structure':
            NumItems = self.listWidget_em.count()
            for i in range(NumItems):
                self.listWidget_em.item(i).setSelected(True)
            #end for
            self.em_set = set(self.em_list)
            #
        elif WhichList == 'Graph':
            NumItems = self.listWidget_graph.count()
            for i in range(NumItems):
                self.listWidget_graph.item(i).setSelected(True)
            #end for
            self.graph_set = set(self.graph_list)
            #
        elif WhichList == 'Data File':
            NumItems = self.listWidget_data_file.count()
            for i in range(NumItems):
                self.listWidget_data_file.item(i).setSelected(True)
            #end for
            self.data_file_set = set(self.data_file_list)
            #
        elif WhichList == 'Output Equation':
            NumItems = self.listWidget_out_eqn.count()
            for i in range(NumItems):
                self.listWidget_out_eqn.item(i).setSelected(True)
            #end for
            self.out_eqn_set = set(self.out_eqn_list)
            #
        elif WhichList == 'Optimization Goal':
            NumItems = self.listWidget_opt_goal.count()
            for i in range(NumItems):
                self.listWidget_opt_goal.item(i).setSelected(True)
            #end for
            self.opt_goal_set = set(self.opt_goal_list)
            #
        elif WhichList == 'Yield Goal':
            NumItems = self.listWidget_yield_goal.count()
            for i in range(NumItems):
                self.listWidget_yield_goal.item(i).setSelected(True)
            #end for
            self.yield_goal_set = set(self.yield_goal_list)
            #        
        #end if
        #
    def UnselectAll(self, WhichList):#----------------------------------------------
        if WhichList == 'Schematic':
            NumItems = self.listWidget_schem.count()
            for i in range(NumItems):
                self.listWidget_schem.item(i).setSelected(False)
            #end for
            self.schem_set = set()
            #
        elif WhichList == 'System Diagram':
            NumItems = self.listWidget_SystemDiagram.count()
            for i in range(NumItems):
                self.listWidget_SystemDiagram.item(i).setSelected(False)
            #end for
            self.schem_set = set()
            #
        elif WhichList == 'EM Structure':
            NumItems = self.listWidget_em.count()
            for i in range(NumItems):
                self.listWidget_em.item(i).setSelected(False)
            #end for
            self.em_set = set()
            #
        elif WhichList == 'Graph':
            NumItems = self.listWidget_graph.count()
            for i in range(NumItems):
                self.listWidget_graph.item(i).setSelected(False)
            #end for
            self.graph_set = set()
            #
        elif WhichList == 'Data File':
            NumItems = self.listWidget_data_file.count()
            for i in range(NumItems):
                self.listWidget_data_file.item(i).setSelected(False)
            #end for
            self.schem_set = set()
            #
        elif WhichList == 'Output Equation':
            NumItems = self.listWidget_out_eqn.count()
            for i in range(NumItems):
                self.listWidget_out_eqn.item(i).setSelected(False)
            #end for
            self.out_eqn_set = set()
            #
        elif WhichList == 'Optimization Goal':
            NumItems = self.listWidget_opt_goal.count()
            for i in range(NumItems):
                self.listWidget_opt_goal.item(i).setSelected(False)
            #end for
            self.opt_goal_set = set()
            #
        elif WhichList == 'Yield Goal':
            NumItems = self.listWidget_yield_goal.count()
            for i in range(NumItems):
                self.listWidget_yield_goal.item(i).setSelected(False)
            #end for
            self.yield_goal_set = set()
            #      
        #end if
        #    
    def MainTabHandler(self):#-----------------------------------------------------
        Tab_label = {0:'One', 1:'Two'}[self.tabWidget.currentIndex()]
        #    
    def PerformCleanup(self):#---------------------------------------
        NumRemoveSchem = len(self.schem_set)
        schem_set_list = list(self.schem_set)
        for i in range(NumRemoveSchem):
            self.Project.remove_circuit_schematic(schem_set_list[i])
        #end for
        self.schem_set = set()
        #
        NumRemoveSysDiag = len(self.sysdiag_set)
        sysdiag_set_list = list(self.sysdiag_set)
        for i in range(NumRemoveSysDiag):
            self.Project.remove_system_diagram(sysdiag_set_list[i])
        #end for
        self.sysdiag_set = set()
        #
        NumRemoveEM = len(self.em_set)
        em_set_list = list(self.em_set)
        for em_remove_name in em_set_list:
            for em_idx in range(self.awrde.Project.EMStructures.Count):
                if self.awrde.Project.EMStructures[em_idx].Name == em_remove_name:
                    self.awrde.Project.EMStructures.Remove(em_idx+1)
                    break
                #end if
            #end for
        #end for
        self.em_set = set()
        #
        NumRemoveGraph = len(self.graph_set)
        graph_set_list = list(self.graph_set)
        for i in range(NumRemoveGraph):
            self.Project.remove_graph(graph_set_list[i])
        #end for
        self.graph_set = set()
        #
        NumRemoveDataFile = len(self.data_file_set)
        data_file_set_list = list(self.data_file_set)
        for i in range(NumRemoveDataFile):
            self.Project.remove_data_file(data_file_set_list[i])
        #end for
        self.data_file_set = set()
        #
        NumRemoveOutEqn = len(self.out_eqn_set)
        out_eqn_set_list = list(self.out_eqn_set)
        for i in range(NumRemoveOutEqn):
            self.Project.remove_output_equations_document(out_eqn_set_list[i])
        #end for
        self.out_eqn_set = set()
        #
        NumRemoveOptGoal = len(self.opt_goal_set)
        opt_goal_set_list = list(self.opt_goal_set)
        for i in range(NumRemoveOptGoal):
            self.Project.remove_optimization_goal(opt_goal_set_list[i])
        #end for
        self.opt_goal_set = set()
        #
        NumRemoveYieldGoal = len(self.yield_goal_set)
        yield_goal_set_list = list(self.yield_goal_set)
        for i in range(NumRemoveYieldGoal):
            self.Project.remove_yield_goal(yield_goal_set_list[i])
        #end for
        self.yield_goal_set = set()
        #        
        self.PopulateLists()
        #
    def PopulateLists(self):#---------------------------------------------
        self.schem_list = self.Project.circuit_schematics_name_list
        self.listWidget_schem.clear()
        self.listWidget_schem.addItems(self.schem_list)
        #
        self.sysdiag_list = self.Project.system_diagram_name_list
        self.listWidget_SystemDiagram.clear()
        self.listWidget_SystemDiagram.addItems(self.sysdiag_list)
        #
        self.em_list = list()
        for em_doc in self.awrde.Project.EMStructures:
            self.em_list.append(em_doc.Name)
        #end for
        self.listWidget_em.clear()
        self.listWidget_em.addItems(self.em_list)        
        #
        self.graph_list = self.Project.graph_name_list
        self.listWidget_graph.clear()
        self.listWidget_graph.addItems(self.graph_list)
        #
        self.data_file_list = self.Project.data_file_names_list
        self.listWidget_data_file.clear()
        self.listWidget_data_file.addItems(self.data_file_list)
        #
        self.out_eqn_list = self.Project.output_equations_list
        self.listWidget_out_eqn.clear()
        self.listWidget_out_eqn.addItems(self.out_eqn_list)
        #
        self.out_eqn_list = self.Project.output_equations_list
        self.listWidget_out_eqn.clear()
        self.listWidget_out_eqn.addItems(self.out_eqn_list)
        #
        self.opt_goal_dict = self.Project.optimization_goals_dict
        self.opt_goal_list = list()
        NumOptGoals = len(self.opt_goal_dict)
        for i in range(NumOptGoals):
            opt_goal = self.opt_goal_dict[i]
            self.opt_goal_list.append(opt_goal.goal_name)
        #end for
        self.listWidget_opt_goal.clear()
        self.listWidget_opt_goal.addItems(self.opt_goal_list)
        #
        self.yield_goal_dict = self.Project.yield_goals_dict
        self.yield_goal_list = list()
        NumYieldGoals = len(self.yield_goal_dict)
        for i in range(NumYieldGoals):
            yield_goal = self.yield_goal_dict[i]
            self.yield_goal_list.append(yield_goal.goal_name)
        #end for
        self.listWidget_yield_goal.clear()
        self.listWidget_yield_goal.addItems(self.yield_goal_list)
        #        
    def Cancel(self):#------------------------------------------------
        self.close()
        #
#
#*************************************************************
#
#Setup------------------------------------------------
app = QApplication([])    #Objct variable for the PyQT GUI
window = MainWindow()     #Assign object variable to entry point of the GUI (MainWindow)
window.show()
#
#Main-----------------------------------------------------
app.exec()                #Executel GUI
#
#Exit--------------------------------------------------
print('')
print('Done . . .')